lexer grammar Kodkodi;

@header {
package de.tum.in.isabelle.Kodkodi;
}
@members {
public void emitErrorMessage(String message) {
    System.err.println(message);
}
}

// $ANTLR src "src/Kodkodi.g" 1695
ATOM_NAME:      'A' NAT;
// $ANTLR src "src/Kodkodi.g" 1696
UNIV_NAME:      'u' NAT;
// $ANTLR src "src/Kodkodi.g" 1697
OFFSET_UNIV_NAME:
                'u' NAT '@' NAT;
// $ANTLR src "src/Kodkodi.g" 1699
TUPLE_NAME:     ('P' | 'T' NAT '_') NAT;
// $ANTLR src "src/Kodkodi.g" 1700
RELATION_NAME:  ('s' | 'r' | 'm' NAT '_') NAT '\''?;
// $ANTLR src "src/Kodkodi.g" 1701
VARIABLE_NAME:  ('S' | 'R' | 'M' NAT '_') NAT '\''?;
// $ANTLR src "src/Kodkodi.g" 1702
TUPLE_SET_REG:  '$' ('a' | 'p' | 't' NAT '_') NAT;
// $ANTLR src "src/Kodkodi.g" 1703
TUPLE_REG:      '$' ('A' | 'P' | 'T' NAT '_') NAT;
// $ANTLR src "src/Kodkodi.g" 1704
FORMULA_REG:    '$f' NAT;
// $ANTLR src "src/Kodkodi.g" 1705
REL_EXPR_REG:   '$e' NAT;
// $ANTLR src "src/Kodkodi.g" 1706
INT_EXPR_REG:   '$i' NAT;

// $ANTLR src "src/Kodkodi.g" 1708
NUM:            (PLUS | MINUS)? '0'..'9'+;
// $ANTLR src "src/Kodkodi.g" 1709
fragment NAT:   '0' | '1'..'9' '0'..'9'*;
// $ANTLR src "src/Kodkodi.g" 1710
STR_LITERAL:    '"' ~('"' | '\n')* '"';
// $ANTLR src "src/Kodkodi.g" 1711
WHITESPACE:     (' ' | '\n' | '\r' | '\t' | '\v')+ { skip(); };
// $ANTLR src "src/Kodkodi.g" 1712
INLINE_COMMENT: '//' ~('\n')* { skip(); };
// $ANTLR src "src/Kodkodi.g" 1713
BLOCK_COMMENT:  '/*' (options { greedy = false; } : .)* '*/' { skip(); };

// $ANTLR src "src/Kodkodi.g" 1715
AMP:            '&';
// $ANTLR src "src/Kodkodi.g" 1716
AND:            '&&';
// $ANTLR src "src/Kodkodi.g" 1717
ARROW:          '->';
// $ANTLR src "src/Kodkodi.g" 1718
COLON_EQ:       ':=';
// $ANTLR src "src/Kodkodi.g" 1719
BAR:            '|';
// $ANTLR src "src/Kodkodi.g" 1720
BRACE_LEFT:     '{';
// $ANTLR src "src/Kodkodi.g" 1721
BRACE_RIGHT:    '}';
// $ANTLR src "src/Kodkodi.g" 1722
BRACKET_LEFT:   '[';
// $ANTLR src "src/Kodkodi.g" 1723
BRACKET_RIGHT:  ']';
// $ANTLR src "src/Kodkodi.g" 1724
COLON:          ':';
// $ANTLR src "src/Kodkodi.g" 1725
COMMA:          ',';
// $ANTLR src "src/Kodkodi.g" 1726
DIVIDE:         '/';
// $ANTLR src "src/Kodkodi.g" 1727
DOT:            '.';
// $ANTLR src "src/Kodkodi.g" 1728
DOT_DOT:        '..';
// $ANTLR src "src/Kodkodi.g" 1729
EQ:             '=';
// $ANTLR src "src/Kodkodi.g" 1730
GE:             '>=';
// $ANTLR src "src/Kodkodi.g" 1731
GT:             '>';
// $ANTLR src "src/Kodkodi.g" 1732
HASH:           '#';
// $ANTLR src "src/Kodkodi.g" 1733
HAT:            '^';
// $ANTLR src "src/Kodkodi.g" 1734
IFF:            '<=>';
// $ANTLR src "src/Kodkodi.g" 1735
IFNO:           '\\';
// $ANTLR src "src/Kodkodi.g" 1736
IMPLIES:        '=>';
// $ANTLR src "src/Kodkodi.g" 1737
LT:             '<';
// $ANTLR src "src/Kodkodi.g" 1738
LE:             '<=';
// $ANTLR src "src/Kodkodi.g" 1739
MINUS :         '-';
// $ANTLR src "src/Kodkodi.g" 1740
MODULO:         '%';
// $ANTLR src "src/Kodkodi.g" 1741
NOT:            '!';
// $ANTLR src "src/Kodkodi.g" 1742
OVERRIDE :      '++';
// $ANTLR src "src/Kodkodi.g" 1743
OR:             '||';
// $ANTLR src "src/Kodkodi.g" 1744
PAREN_LEFT:     '(';
// $ANTLR src "src/Kodkodi.g" 1745
PAREN_RIGHT:    ')';
// $ANTLR src "src/Kodkodi.g" 1746
PLUS:           '+';
// $ANTLR src "src/Kodkodi.g" 1747
SEMICOLON:      ';';
// $ANTLR src "src/Kodkodi.g" 1748
SHA:            '>>';
// $ANTLR src "src/Kodkodi.g" 1749
SHL:            '<<';
// $ANTLR src "src/Kodkodi.g" 1750
SHR:            '>>>';
// $ANTLR src "src/Kodkodi.g" 1751
STAR:           '*';
// $ANTLR src "src/Kodkodi.g" 1752
TILDE:          '~';

// $ANTLR src "src/Kodkodi.g" 1754
ABS:            'abs';
// $ANTLR src "src/Kodkodi.g" 1755
ACYCLIC:        'ACYCLIC';
// $ANTLR src "src/Kodkodi.g" 1756
ALL:            'all';
// $ANTLR src "src/Kodkodi.g" 1757
BITS:           'Bits';
// $ANTLR src "src/Kodkodi.g" 1758
BIT_WIDTH:      'bit_width';
// $ANTLR src "src/Kodkodi.g" 1759
BOUNDS:         'bounds';
// $ANTLR src "src/Kodkodi.g" 1760
DELAY:          'delay';
// $ANTLR src "src/Kodkodi.g" 1761
ELSE:           'else';
// $ANTLR src "src/Kodkodi.g" 1762
FALSE:          'false';
// $ANTLR src "src/Kodkodi.g" 1763
FLATTEN:        'flatten';
// $ANTLR src "src/Kodkodi.g" 1764
FUNCTION:       'FUNCTION';
// $ANTLR src "src/Kodkodi.g" 1765
IDEN:           'iden';
// $ANTLR src "src/Kodkodi.g" 1766
IF:             'if';
// $ANTLR src "src/Kodkodi.g" 1767
IN:             'in';
// $ANTLR src "src/Kodkodi.g" 1768
INT:            'Int';
// $ANTLR src "src/Kodkodi.g" 1769
INT_BOUNDS:     'int_bounds';
// $ANTLR src "src/Kodkodi.g" 1770
INTS:           'ints';
// $ANTLR src "src/Kodkodi.g" 1771
LET:            'let';
// $ANTLR src "src/Kodkodi.g" 1772
LONE:           'lone';
// $ANTLR src "src/Kodkodi.g" 1773
NO:             'no';
// $ANTLR src "src/Kodkodi.g" 1774
NONE:           'none';
// $ANTLR src "src/Kodkodi.g" 1775
ONE:            'one';
// $ANTLR src "src/Kodkodi.g" 1776
RELATION:       'relation';
// $ANTLR src "src/Kodkodi.g" 1777
SET:            'set';
// $ANTLR src "src/Kodkodi.g" 1778
SGN:            'sgn';
// $ANTLR src "src/Kodkodi.g" 1779
SHARING:        'sharing';
// $ANTLR src "src/Kodkodi.g" 1780
SKOLEM_DEPTH:   'skolem_depth';
// $ANTLR src "src/Kodkodi.g" 1781
SOLVE:          'solve';
// $ANTLR src "src/Kodkodi.g" 1782
SOLVER:         'solver';
// $ANTLR src "src/Kodkodi.g" 1783
SOME:           'some';
// $ANTLR src "src/Kodkodi.g" 1784
SUM:            'sum';
// $ANTLR src "src/Kodkodi.g" 1785
SYMMETRY_BREAKING:
                'symmetry_breaking';
// $ANTLR src "src/Kodkodi.g" 1787
THEN:           'then';
// $ANTLR src "src/Kodkodi.g" 1788
TIMEOUT:        'timeout';
// $ANTLR src "src/Kodkodi.g" 1789
TOTAL_ORDERING: 'TOTAL_ORDERING';
// $ANTLR src "src/Kodkodi.g" 1790
TRUE:           'true';
// $ANTLR src "src/Kodkodi.g" 1791
UNIV:           'univ';
